Page MenuHome

Dyntopo Roadmap
Confirmed, NormalPublicDESIGN

Tokens
"Love" token, awarded by kfir."Dislike" token, awarded by santiagoshang."Dislike" token, awarded by juanito49."Yellow Medal" token, awarded by franMarz."Party Time" token, awarded by Jules."Like" token, awarded by ofuscado."Like" token, awarded by JohnMalcolm1970."Burninate" token, awarded by Rubens91."Like" token, awarded by RodDavis."Love" token, awarded by dcvertice."Dislike" token, awarded by Ztreem."Dislike" token, awarded by DKesserich."Like" token, awarded by Frozen_Death_Knight."Love" token, awarded by irfan."Heartbreak" token, awarded by 616."Love" token, awarded by Kronk."Like" token, awarded by roman13."Heartbreak" token, awarded by CobraA."Dislike" token, awarded by EMeurat."Dislike" token, awarded by julperado."Dislike" token, awarded by mankysee."Heartbreak" token, awarded by rice."Dislike" token, awarded by nutel."Dislike" token, awarded by ebarranco."Like" token, awarded by Loner."Dislike" token, awarded by MetinSeven."Like" token, awarded by Brandon777."Love" token, awarded by plundh.
Authored By
Pablo Dobarro (pablodp606)
Feb 17 2020, 6:55 PM

Description

The goal of this task is to discuss the current status of Dyntopo as well as to evaluate the future development of this feature.

Currently in Blender we have the Voxel Remesher, which covers the same use case as Dyntopo and it does not have major issues that affects its functionality. Because of that, I don’t consider that developing Dyntopo specific features right now is a priority.

Dyntopo use cases

  • Some brushes that produces big shape deformations (like snake hook) are much more intuitive to use with Dyntopo than with the voxel remesher.
  • Some new clay brushes look much better and more detailed with the Dyntopo triangulation enabled. This does not mean that they are bad with static topology, but supporting this feature adds extra polish to the software.
  • Dyntopo is the only way to work with dynamic topology in surfaces that do not represent a volume (like cloth). Quadrilfow + Multires should work for these use cases, but currently Quadriflow is not 100% reliable.

Current Issues

  • Dyntopo performance is not enough, even for stylized models. It can only be used for sketching simple shapes. Regardless of the hardware, Dyntopo starts lagging at around 150k vertices, and it becomes almost unusable at 500k. When working with the voxel remesher, it is possible to work on models up to 20M vertices. In order for Dyntopo to be usable at the same level as the voxel remesher workflow it needs to be in the order of 30 times faster, so I don’t think that any of the optimizations listed in T68873 are enough for that.
  • When developing new features I’m always testing them with the Voxel Remesher workflow, but some people keep using Dyntopo as their primary dynamic topology system. This makes that almost all bugs I fix during the development of new features are related to Dyntopo compatibility and not to the feature itself, which does not make much sense as Dyntopo is something that is not active being developed.
  • The voxel remesher provides almost the same functionality as Dyntopo and it is much easier to maintain because it is completely decoupled from the sculpting code. With the development of the volume objects and its modifiers stack, it will also get new features automatically without dedicating extra time to it.
  • Dyntopo was always explained as an optimization (it adds geometry detail only when it is needed) when actually it is much slower than using regular meshes or multires and it takes a much more memory. This causes a bad impression and confusion on users as they usually work with Dyntopo without being aware of the huge performance implications it has, so they think that the regular sculpting performance in Blender is that slow.

Solutions

  • Deprecate Dyntopo: Dyntopo is a feature that was not developed for years, but it exposed in the UI next to the Voxel Remesher. This may confuse users as they may think that both features are equivalent, but one of them is being active developed and supported and the other one is not and it has functional issues. In order to avoid this, we could explicitly say that Dyntopo is deprecated or a experimental feature. In order to do that, a possible solution could be:
    • Remove the global Dyntopo toggle and hide it as a experimental feature.
    • Add a per tool Dyntopo option in tools where it creates an effect that can’t be easily achieved with the remesher (snake hook, for example).
  • Replace Dyntopo with volume sculpting: Supporting levels set in the volume object is already planned and it should be possible to add a sculpt mode to edit level sets. I don’t know what kind of performance we can expect from level set sculpting or how much work would it be supporting the current tools in that mode. We can wait until we can test it and if performance is enough, we can simply remove Dyntopo and replace it which a voxel based sculpting solution.
  • Design some structural optimizations: I think that using BMesh as the Dyntopo mesh structure is too much complexity. Dyntopo only needs to store triangles, split and merge them, so it does not need a structure that can represent all kinds of ngos, loose edges, non manifold geometry... This does not mean that we should remove the PBVH_BMESH code, as it may be useful in the future for some other kind of tools that may need to do topology modifications or more advanced mesh queries. Probably using a much simpler mesh structure specifically designed for this use case could improve performance and memory usage, but I can’t evaluate the scope of this project or the time that is needed to make it.

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

If Voxel Remesher replaces Dyntopo almost completely, isn't Dyntopo better save to only where no one can replace Dyntopo?

Aaron Carlisle (Blendify) changed the task status from Needs Triage to Confirmed.Feb 17 2020, 8:32 PM
Aaron Carlisle (Blendify) changed the subtype of this task from "Report" to "Design".

You'll probably loose people with just deleting Dyntopo. A replacement would be needed, like you said with volume sculpting.


Do have to say in my honest opinion. Just the voxel operator alone has sped up the workflow by 100x. Though Dyntopo does have it's advantages for quick small details, it has been lacking in performance on my end since 2.8. I've been using dyntopo since around 2.74 and stopped once the voxel operator was added in.

🤞I'm hoping that volume sculpting goes well!
Good luck with this

Paul (rice) rescinded a token.

Voxel remesh it's a good tool but is a different way to work, a different tool. If you want to get rid of dyntopo old code it's fine but you have to replace it with a newdynamic solution then. You can't say remeshing volume is better than dynamic topology because it isn't. I really like the idea of having both ways of work.

Please consider solution number 3 (optimize and improve the Dyntopo experience). The system right now is the only way to create a complex and highly detailed organic model using just the sculpt tools, something which is far easier and more accessible than old-school box modeling.

One of the primary arguments for removal is that no one is developing it, but people contributed generously to your original Patreon in the hopes it is one of the areas you would improve.

Ruslan (Loner) added a comment.EditedFeb 17 2020, 11:39 PM

I don't know what you're all attached to removing dyntopo. If there's an alternative and an alternative that's better than dyntopo, I'd be happy to. This is better than to develop two paths (I mean voxel remesh and dyntopo) and do twice as much work, it is better to have one path.
Why can't anyone hear that replacing it with another type that's can be better than dyntopo is not bad. Pablo offers an alternative in the form of volume sculpting. I'd like to take a look at this alternative before screaming about how bad the removal is. Pablo offers three solutions. I agree with the second solution as dyntopo with volume sculpting.

This comment was removed by Ruslan (Loner).

there is no alternative to dynotopo as it stands now because yes, some people works only with that but much more people using it as a local multi-resolution thing(like sculpt a blade with a low resolution mesh and add a sharp edge and cracks with dynotopo) and there are no ways no replicate that workflow with current tools build on top of voxel remesh workflow. Why would you want to replicate it? Because it offers much greater flexibility in geometry creation than any other way(especially with a flood-the-geometry-with-polygons kind of way).

Yes, it can be slow, but a much better alternative than just removing it would be to find a way to preserve said functionality. As far as I can read through the proposal only a third point in the solutions' part is more or less offers a solution to a problem the current dynotopo system is solving. But this point is extremely vague sadly.

There also "topology rake" feature of dyntopo which allows to orient edges in the direction of the stroke for sharper creases. Maybe if re-meshing with spline guides to control edge flow will be introduced...

If the current implementation of Dyntopo is going to be removed then please look for a way to replace it with something that has the same functionality. Voxel remesher is a great addition but it's not the same and it is not a replacement for Dyntopo.

Hi! I'm a 3d Print designer from Argentina.

I use the new Voxel Remesher a lot and it's wonderful. It helps me with the intern geometry or a bad boolean.

In the 3D print world, the models has to have a very high resolution, but sometimes I need a little detail in a blade (like it was said above) and make a Remesh in a full model takes several minutes and sometimes freezes blender, so I found a beter solution in paint a little with Dynotopo and then use the sculpt brush normally.

Dyntopo is actually one of the best solution out there, it's a shame that's suffereing from bad performance and haven't been developed for many years but it shouldn't be removed at all, that would be a huge mistake.

Put it as experimental if you guys are worried about people's perception, and like everyone else have said, optimize and improve it over time because voxel remesher is not perfect either and it's a different workflow imo.

Hi, I use dyntopo as a workflow even on machines with very basic resources, it gives me more elasticity than remensh.

For some reason, Zbrush started using Dyntopo-like technologies and we're going to hide it! If we are going to change dyntopo that it is for a dynamic alternative that is to say to remake them or to put a hand to the one who is ...

The speakers know where this remesh is but we do not see it as a work flow if not as an optional tool, we want to produce oragic pieces with ease, without worrying about technique or in the tool that we have elijismos which is more comfortable.

There are moments to use a brush and there is time to use a pencil let us choose that moment to us, in zbrush the two workflows coexist.

3D coat can sculpt with dyntopo models with more than 50 millions polys.

I dont miss the 'live' remeshing from dyntopo too much.

My main concern here … how to preserve details in voxel sculpting?

After I pushed voxel sculpting to my machine's limits (20 million polygon figure), I found some issues with voxel sculpting.

  • voxel remeshing wipes away details. (Finger nails, mouth shapes, eye lids, and so on). For multiple times I had to re-sculpt such details. Very time consuming and annoying. I found that higher density voxel remeshing does not keep safe details. After some pose transformations voxel remeshing again wipes details. Even on a resolution which would have worked for the details (if untouched by posing).
  • Lets assume we increase overall resolution to preserve details. Much excess geometry where it is not needed, to get enough detail where its needed.
  • Adaptive voxel remeshing seems not mature. Large areas without important details get resolution pushed. Important areas with much details are ignored and wiped. And, after adaptive voxel remesh, smooth brush creates artifacts you wont get rid of, unless you remesh with unified density.

Naming these problems does not mean that I dont enjoy voxel sculpting. Im excited about its possibilities and barely use dyntopo.

Thank you for your efforts.

I was already using the same workflow we use now with dyntopo. The performance drop has always been there, and I've always recommended to my students to use detail flood fill as a way to update the resolution of the mesh and then sculpt with dyntopo turned off. So, personally I won't miss it that much, since I prefer to remesh.

But, there are some use cases that other people have mentioned that make dyntopo useful, plus some shortcomings from the remesher, that make me think that the main problem with dyntopo is how it is shown in the UI and the workflow?

Everytime I had to explain the use of dyntopo people get confused, mostly from the different modes and options.

I feel that part of the problem in this is my feedback to Nicholas when he was working on implementing dyntopo, so apologies for my part on this mess.

I wouldn't mind dyntopo being dropped, but I think a simpler/more defined workflow for dyntopo could be worth a thought.

Thanks for all your work, Pablo!

I don't mind the actual Dyntopo getting dropped, as long as a replacement for it gets added, specifically a way to have localized detail, which is its main strenght.
In a traditional sculpting workflow, let's say the creation of a creature for a videogame, Dyntopo is only useful in the early stages, where you are doing some sketching and getting the rough forms in, then from there remesh and multires are needed to add all the final detail, then retopo, baking, etc. In this case the voxel remesher can very well be a replacement for dyntopo.

But, as others have mentioned there are cases where the dyntopo meshes can be used directly for rendering/3d printing (think about concept art or miniature figures for example). I personally use it a lot for illustration and advertisement renders, where it's mostly still images with some further refining/polishing in Photoshop. There are cases where the ability to add detail only where needed are very helpful, we don't always need to have the same polygon density over the whole mesh; and without dyntopo there would be no way to do that.

Volume/voxel sculpting like 3DCoat may not be a propper replacement either, the problem with that approach is that it gets very difficult to add detail because it feels like working with wet clay. It doesn't allow to have more or less detail on certain areas.

I think what needs to be done is to optimize its performance and have a clearer UI, like greying out options and/or brushes that don't work with Dyntopo for example. The Sculptris Pro system in Zbrush is really useful, but it's clear to the user that most of the tools and options for multires sculpting won't be available for it. Would that be possible? To have an optimized dyntopo system that excels precisely on the ability to have localized detail?

Totaly with you guys. We can drop dyntopo out of blender, im not even touching anything past 2.80 and since i switched back to zbrush i do not care much about sculpting in blender. I think its time do drop cycles since we have eevee. Blender has bright future.

Mh …
I guess images are stronger then words.

This video shows the problem I mentioned ago.
Video shows default cube. On each step, the cube gets rotated and remeshed. Look what happens to the cube corners.
Lets wipe the default cube

Do you really think that performance issue is really (ONLY) due to Dyntopo itself?
I don't think so, at least not totally, just parcial, as it's an algorithm that may be improved SO MUCH with some love and coordination/help if needed.

At the time of writing this: With the last Blender 2.82, stable, the default cube, go to sculpting, remesh with 0.001.... 1 minute or more waiting for it with intention to crash.... OK, 24M verts, good navigation... 9GB of RAM used... then just draw brush with a very low size like 50px... SUPER LAGGED. Now playing around with the cube a little for over 10 minutes... +17 GBs of RAM. No dyntopo used, just voxel remesh but impossible to work with.

So that's the question,
Do you really think that performance issue is really (ONLY) due to Dyntopo itself?

My experience is yeah, dyntopo is awful, amazing lagg with 500k, but I can have better topology, less RAM usage (performance, just because of the vertex count) and better detail and control where I really want with just 200k using dyntopo without having a mesh with +20M with even LESS detail than the mesh with dyntopo, with a slow and not so good adaptive remesher which with you even lose details and have to spend more and more time fixing and sculpting the same multiple times... and a multires broken (well, is being worked that it's cool), so what are the alternatives? Buying a super computer with 1TB of RAM because of the bad performance with HP meshes? Not everyone can hava a great computer but I don't have a bad computer, so make no sense for me, I think those performance issues are more from Blender itself... And even me, I wish I could help with something as I have programming knowledge... so I know it's not that easy to solve to just cross the fingers and wait to magically happen, but sure we all can have the resources and time to fix it all anytime soon or later.

I'm not saying you are doing a bad work and so, you are doing really well, people really love new features and new things, yeah, but above all, people want things to be stable, intuitive and with great performance over ALL their workflows, because if you have the tools but not a good base to use those tools with the freedom the user want for HP sculpting, is not a workflow overall, is a thing that is there, it's cool and people just use few times because it's cool to share on twitter. I try to be really critical with Blender to be realistic with the immense improvement space there is, before putting cool things inside Blender, don' take me wrong.

In the other hand, a remesher will never replace dynamic topology, whatever it is specific for sculpting or not (I sometimes doubt). They're completely different workflows.

If You really have time to make new workflows and redesign an entire workflow as Multires is, You have time to take a look into Dyntopo improvements soon or late, as well as the data structure that it uses and so on.

.
You really should:

  • Check what it that RAM eater that goes up beyond infinite.
  • Improve mesh structures to improve performance while sculpting HP meshes.
  • Improve Dyntopo or redesign it as well as Multires, even the proposal you made is worthwhile and is interesting!! But please don't deprecate such workflow, at least is there's space to improvements.

Then as developer adding new features and tools will be just a pleasure and every artist will be pleased as well, but if it stills some kind of impact in performance and is bad designed in code, it won't be a pleasure for anyone.

CobraA (CobraA) added a comment.EditedFeb 18 2020, 5:53 PM

Mh …
I guess images are stronger then words.

This video shows the problem I mentioned ago.
Video shows default cube. On each step, the cube gets rotated and remeshed. Look what happens to the cube corners.
Lets wipe the default cube

It seems you haven't enabled preserve volume & fix poles you need them to avoid artefacts, because the voxel remeshing is a grid parallel to faces of the Mesh..watch his talk at the BConf19 to understand how it works.
also there is this patch D6204 that needs to be added.

Hi! I sculpt a lot in Blender (@ lopoisaac in twitter) and IMHO I agree with the 1st solution: I really like dynotopo but there is not point in keeping something unmaintained that has performance issues from day 1 (should be hidden as "experimental" for now). I use it sometimes and feel a great respect for all the developers who made it possible but the Blender Game Engine is also gone and no one died (I hope).

It seems you haven't enabled preserve volume & fix poles you need them to avoid artefacts, because the voxel remeshing is a grid parallel to faces of the Mesh..watch his talk at the BConf19 to understand how it works.
also there is this patch D6204 that needs to be added.

Mh …
I forgot these kinds of artifacts. Very different thing. Smooth brush fixed them in my workflow. But its nice to hear that its gonna be fixed.

My video showed how voxel remeshing wipes details. Checking "preserve volumes" and "fix poles" does not fix this, sadly.
If you like, you can try yourself. Just like in the video, with both checked, and see what happens.

CobraA (CobraA) added a comment.EditedFeb 19 2020, 5:29 AM

It seems you haven't enabled preserve volume & fix poles you need them to avoid artefacts, because the voxel remeshing is a grid parallel to faces of the Mesh..watch his talk at the BConf19 to understand how it works.
also there is this patch D6204 that needs to be added.

Mh …
I forgot these kinds of artifacts. Very different thing. Smooth brush fixed them in my workflow. But its nice to hear that its gonna be fixed.

My video showed how voxel remeshing wipes details. Checking "preserve volumes" and "fix poles" does not fix this, sadly.
If you like, you can try yourself. Just like in the video, with both checked, and see what happens.

I didn't say it's perfect,but without those options your mesh will shrink and get artefects..etc that patch will help in preserving details a little bit and maybe we'll need even more improvements in the future to get it as good as in the other sculpting app.

Removing dyntopo should be a hard no from anybody.

As many have said, the voxel remeshing workflow is not in any way a functional replacement for dynamic topology.

Further, the assertion that it's unusable for anything other than simple shapes is just wrong. There are metric tonnes of examples of high detail dyntopo sculpts dating back years all over youtube and BlenderArtists, in both photo real and heavily stylized art styles.

And it's a bit disingenuous to say that a 20 million vertex remeshed mesh sculpts as fast as a 500,000 vert dyntopo mesh. How many millions of those verts on the 20 million vert mesh even need to exist? And when you untick the dyntopo box, doesn't the 500,000 vert dyntopo mesh now sculpt just as fast, if not faster, with the benefit of vertex concentration actually being where the details are, instead of spread evenly across the mesh? The problem is the PBVH rebuild on strokes when dyntopo is active, yes?

Could dyntopo be improved? Yes. Obviously. So could everything in Blender.

Should it be thrown away because improving it is hard and you don't have time to do it? Absolutely not.

One should hope that an engineer whose talents are more suited to dealing with the complexities of the drawing code and the underlying math and data structure problems might be found to take a crack at improving it instead. Whatever happened to psy-fi? They were doing a lot of stuff in the dyntopo code a few years back.

I didn't say it's perfect,but without those options your mesh will shrink and get artefects..etc that patch will help in preserving details a little bit and maybe we'll need even more improvements in the future to get it as good as in the other sculpting app.

Just try. ;)

Voxel remesh and dyntopo are two different things, don't throw one away just because it doesn't suite a specific workflow. Everybody doesn't do character sculpts.
Maybe its time again to look at the SculptGL code and see if that could help to optimize dyntopo?
I did i quick test with dyntopo in Blender 2.81a and It worked fine with 2.3 million tris, so why anybody says that it's unworkable at 0.5 million tris, I don't know?
PS. This is on my a laptop (not a cheap laptop)

Okay, people need to stop saying that voxel remesh is a replacement for Dyntopo, it is not. Why do you think zbrush and mudbox just added it to their tool set? In fact, this is one of the best things that happened to zbrush and mudbox recently... And now blender is considering removing it, seriously?

I love dynamesh/voxel remesh but it can't be compared with dynamic tessellation, they are completely different tools, so removing it makes no sense and would just put blender too far behind the other sculpting solutions.

I'd say, finding ways to improve Dyntopo's performance is the only reasonable option here.

I try to find a way to measure detail preservation (with voxel remesher). A way to estimate how voxel remesher performs on different resolutions. Or, a way to see how adaptive/nonadaptive voxel remesh performs.

The Blend file contains a disk like object which has an increasing detail resolution towards its center.

The procedure … perform refine, rotate around z. And repeat.

Lots of "bugs" will probably be a user error.. Known issues will occur more and more as blender gets more popular than it is now.


Dynamic topology..
Zbrush does have issues with brush strokes when the polycount is high in sculptris pro.
Though blender does have issues with dyntopo and triangles currently. Tutorials revolving around dyntopo is sort of flawed.

Most tutorials, on youtube, introduces blender's dyntopo lacks the following ideas:

  • Have a copy of your mesh so you can then reproject the details using shrink-wrap
  • Break up your mesh into chunks while working with dyntopo
  • Try decimating the model before using dyntopo
  • Don't use dyntopo if you want to keep your UV's...

That's just basic knowledge, but a new user will make mistakes and may report it as bugs or flaws..

Either way, dyntopo definitely needs improvements, of course.


Future stuff

Remove the global Dyntopo toggle and hide it as a experimental feature.
Add a per tool Dyntopo option in tools where it creates an effect that can’t be easily achieved with the remesher (snake hook, for example).

Hiding it would be good.. Though, I don't think hiding it will do anything. Online tutorials will still expose it.
A global toggle is still good and easy to manage than just hiding it in individual tools. However... Adding an enable/disable dyntopo per brush/tool for dyntopo would be very nice.
Obviously not for brushes/tools like pose, grab, cloth, vdm, inserts, or trim types. Maybe add a sculpt_capabilities brush setting for this in the brush settings. Preferably in the advanced area.

Probably using a much simpler mesh structure specifically designed for this use case could improve performance and memory usage, but I can’t evaluate the scope of this project or the time that is needed to make it.

I think it would be good to find another developer and/or developers to help along with this part. Splitting the workload would be good...
I wonder if this could be partly a GSoC project to get things rolling? As long as Google accepts another GSoC anyway.

A placeholder approach that might be better than hiding or otherwise disabling dyntopo behind an 'experimental' wall would be to hide or disable the tools that don't currently or even can't work with dyntopo when dyntopo is enabled. I.e. somebody clicks the dyntopo check box, pose brush disappears from the shelf. Untick dyntopo? Pose brush comes back.

NXSK (NXSK) added a subscriber: NXSK (NXSK).EditedFeb 21 2020, 9:42 AM

I think dynatopo is extremely useful in the early sculpting stage. When the base form is done, maybe I will remesh it with voxel or quad to proceed. Zbrush's sculptris pro has the same functionality as dynatopo and it warns users that in this mode some features will not be accessable. So I think if there is a better tool can do the same thing as dynatopo, we can accept that. If not, maybe to optimize dynatopo is a better way.

Dyntopo should be replaced by an optimized version of itsself... If there's no a better option, it shouldn't be deprecated.

Small contribution

Recently we started a survey in some Spanish-speaking telegram groups of bleender and 35 people 8 use remesh, the rest you use dyntopo, I think these things are taken into account for the development of the program, among many other things.

Until there is an alternative equal to or better than dyntopo, one could not speak of the disharmony of hiding it or eliminating it, it cannot even be called experimental, no matter how much we follow Pablo's work and we are happy with what has been done so far, you continue using dyntopo for one that Another task in our workflow.

Will we have to instill programs that weigh 850mb at 15GB or those that hang the operating system to go looking for the details that we cannot achieve in blender?

That changes and greatly delays the workflow especially those who do not have the super machine to make 3D

We appreciate the efforts to improve and add new functions to the sculpture tool, for a stylized sculpture or a supposedly more complete workflow, when each artist tends to create their own workflow and shares it so that another creates their own according to their need.

Design some structural optimizations: I think that using BMesh as the Dyntopo mesh structure is too much complexity. Dyntopo only needs to store triangles, split and merge them, so it does not need a structure that can represent all kinds of ngos, loose edges, non manifold geometry

@Pablo Dobarro (pablodp606) do you think maybe looking at https://stephaneginier.com/sculptgl/ own dynamic topology code could be a way to improve Blender's current implementation of dyntopo? Since you proposed to look at SculptGL for a possible starting point for a new multires, I think it's worth the try to do the same for Dyntopo, what do you think?

@Pablo Dobarro (pablodp606) Dyntopo doesn't need to be as fast and optimal as voxel remesh, because they have different purposes.

Cases when voxel remesh doesn't work:

non manifold surfaces
meshes with sharp edges (hard surface)

you say that voxel remesh is 20x faster or optimal in sculpt mode, but outside sculpt mode, vertex count does matter, a lot. For example importing meshes in other software like substance or for 3D print.

Please consider working in dyntopo instead of deprecating it.

@edwin hernandez (juanito49)
Please check your assumptions.

I can reproduce wiping issue with dyntopo too. Just switch to constant (manual) detail and do a flood fill. This simple experiment shows, that dyntopo flood-fill-all wipes away details, just like current voxel remesh-all does. ("subdivide edge" method does not preserve detail)

If we try a manual detail (flood fill) based dyntopo workflow, we run into exactly same problems like current voxel remesh solution.

With dyntopo we could decide that we leave areas untouched. Its no philosophy, purpose or some other arcane truth.
We could control what we refine, or what we dont like to refine. This is the one and only reason we could preserve detail with dyntopo. As experiment shows (anyone can reproduce), dyntopo itself does not preserve hard surface edges or details.

Here is a good example why voxel remesher should not replace dyntopo https://developer.blender.org/T74385

With dyntopo we could decide that we leave areas untouched. Its no philosophy, purpose or some other arcane truth.

Quite the opposite, that's exactly the workflow philosophy. Change only things we want to change instead of changing everything at once.

So yes, dynotopo's flood fill is exactly the same as voxel remesher in that aspect - it doesn't follow the philosophy of changing local details and keep everything else intact. But when people talk about dynotopo they don't talk about flood fill ,they are talking about a feature that makes the dynotopo tool workflow unique.

Here is a good example why voxel remesher should not replace dyntopo https://developer.blender.org/T74385

Thats a well known limitation of remeshing and definitly not a bug. We could request a feature to avoid those by adding a plane in between geometry thats near. I think it may work? @Pablo Dobarro (pablodp606)